diff -c -r -N irc2.8.21+CSr2/common/send.c irc2.8.21+CSr3/common/send.c
*** irc2.8.21+CSr2/common/send.c	Tue Mar  7 21:42:15 1995
--- irc2.8.21+CSr3/common/send.c	Fri Jun 23 14:55:39 1995
***************
*** 340,347 ****
  # ifdef	USE_VARARGS
  	va_start(vl);
  # endif
! 	for (i = 0; i < MAXCONNECTIONS; i++)
! 		sentalong[i] = 0;
  	for (lp = chptr->members; lp; lp = lp->next)
  	    {
  		acptr = lp->value.cptr;
--- 340,346 ----
  # ifdef	USE_VARARGS
  	va_start(vl);
  # endif
!         bzero((char *)&sentalong,sizeof(sentalong));
  	for (lp = chptr->members; lp; lp = lp->next)
  	    {
  		acptr = lp->value.cptr;
***************
*** 449,479 ****
  {
  	va_list	vl;
  # endif
! 	Reg1	int	i;
! 	Reg2	aClient *cptr;
! 	Reg3	Link	*lp;
  
  # ifdef	USE_VARARGS
  	va_start(vl);
  # endif
! 	for (i = 0; i <= highest_fd; i++)
! 	    {
! 		if (!(cptr = local[i]) || IsServer(cptr) ||
! 		    user == cptr || !user->user)
! 			continue;
! 		for (lp = user->user->channel; lp; lp = lp->next)
! 			if (IsMember(cptr, lp->value.chptr))
! 			    {
  # ifdef	USE_VARARGS
! 				sendto_prefix_one(cptr, user, pattern, vl);
  # else
! 				sendto_prefix_one(cptr, user, pattern,
! 						  p1, p2, p3, p4,
! 						  p5, p6, p7, p8);
  # endif
! 				break;
! 			    }
! 	    }
  	if (MyConnect(user))
  # ifdef	USE_VARARGS
  		sendto_prefix_one(user, user, pattern, vl);
--- 448,481 ----
  {
  	va_list	vl;
  # endif
! 	register Link *channels;
! 	register Link *users;
! 	register aClient *cptr;
  
  # ifdef	USE_VARARGS
  	va_start(vl);
  # endif
! 	bzero((char *)&sentalong,sizeof(sentalong));
! 	if (user->user)
! 	for (channels=user->user->channel;channels;channels=channels->next)
! 		for(users=channels->value.chptr->members;users;users=users->next)
! 		{
! 			cptr = users->value.cptr;
! 			if (!MyConnect(cptr) || (cptr == user) ||
! 					sentalong[cptr->fd])
! 				continue;
! 			sentalong[cptr->fd]++;
  # ifdef	USE_VARARGS
! 			sendto_prefix_one(cptr, user, pattern, vl);
  # else
! 			sendto_prefix_one(cptr, user, pattern,
! 				  p1, p2, p3, p4, p5, p6, p7, p8);
  # endif
! 		}
! 
! /* maybe (cptr == user) could be taken out above and this
!    part of code removed?  -- CS */
! 
  	if (MyConnect(user))
  # ifdef	USE_VARARGS
  		sendto_prefix_one(user, user, pattern, vl);
***************
*** 863,870 ****
  #ifdef	USE_VARARGS
  	va_start(vl);
  #endif
! 	for (i=0; i <= highest_fd; i++)
! 		sentalong[i] = 0;
  	for (cptr = client; cptr; cptr = cptr->next)
  	    {
  		if (!SendWallops(cptr))
--- 865,871 ----
  #ifdef	USE_VARARGS
  	va_start(vl);
  #endif
!         bzero((char *)&sentalong,sizeof(sentalong));
  	for (cptr = client; cptr; cptr = cptr->next)
  	    {
  		if (!SendWallops(cptr))
diff -c -r -N irc2.8.21+CSr2/include/comstud.h irc2.8.21+CSr3/include/comstud.h
*** irc2.8.21+CSr2/include/comstud.h	Mon Jun 19 08:05:05 1995
--- irc2.8.21+CSr3/include/comstud.h	Tue Jun 20 01:56:58 1995
***************
*** 1,5 ****
--- 1,17 ----
  #ifndef COMSTUD_H
+ #define COMSTUD_H
  
+ /* IDENTD_ONLY      - define this if you only want people running
+                       identd to connect
+               Note:   Non-identd people are allowed on by
+                       not putting a '@' in an I: line...
+                       For example:
+                         I:204.122.*::*eskimo.com::10
+                       let's people on from eskimo.com even
+                       if they aren't running identd
+ */
+ 
+ #define IDENTD_ONLY
  
  /* QUOTE_KLINE      - define this if you want /QUOTE KLINE
  */
***************
*** 110,116 ****
  #undef OPER_CAN_FLOOD2
  
  /* CLIENT_NOTICES - define this if you wish to see client connecting
!                     and exiting notices via /umode +u
  */
  
  #define CLIENT_NOTICES
--- 122,128 ----
  #undef OPER_CAN_FLOOD2
  
  /* CLIENT_NOTICES - define this if you wish to see client connecting
!                     and exiting notices via /umode +c
  */
  
  #define CLIENT_NOTICES
diff -c -r -N irc2.8.21+CSr2/include/dbuf.h irc2.8.21+CSr3/include/dbuf.h
*** irc2.8.21+CSr2/include/dbuf.h	Mon May  2 07:50:13 1994
--- irc2.8.21+CSr3/include/dbuf.h	Thu Jun 22 00:58:32 1995
***************
*** 67,76 ****
  ** as long as a pointer is 4 bytes, we get 2032 bytes for buffer
  ** data after we take away a bit for malloc to play with. -avalon
  */
  typedef struct dbufbuf
      {
  	struct	dbufbuf	*next;	/* Next data buffer, NULL if this is last */
! 	char	data[2032];	/* Actual data stored here */
      } dbufbuf;
  
  /*
--- 67,77 ----
  ** as long as a pointer is 4 bytes, we get 2032 bytes for buffer
  ** data after we take away a bit for malloc to play with. -avalon
  */
+ /* changed to 4080 from 2032 */
  typedef struct dbufbuf
      {
  	struct	dbufbuf	*next;	/* Next data buffer, NULL if this is last */
! 	char	data[4080];	/* Actual data stored here */
      } dbufbuf;
  
  /*
diff -c -r -N irc2.8.21+CSr2/include/patchlevel.h irc2.8.21+CSr3/include/patchlevel.h
*** irc2.8.21+CSr2/include/patchlevel.h	Mon Jun 19 01:29:49 1995
--- irc2.8.21+CSr3/include/patchlevel.h	Thu Jun 22 00:51:07 1995
***************
*** 17,21 ****
   */
  
  #ifndef	PATCHLEVEL
! #define PATCHLEVEL "2.8.21+CSr2"
  #endif
--- 17,21 ----
   */
  
  #ifndef	PATCHLEVEL
! #define PATCHLEVEL "2.8.21+CSr3"
  #endif
diff -c -r -N irc2.8.21+CSr2/ircd/channel.c irc2.8.21+CSr3/ircd/channel.c
*** irc2.8.21+CSr2/ircd/channel.c	Mon Jun 19 09:13:33 1995
--- irc2.8.21+CSr3/ircd/channel.c	Thu Jun 22 00:18:12 1995
***************
*** 1276,1282 ****
--- 1276,1286 ----
  		    {
  			obtmp = tmp;
  			tmp = tmp->next;
+ #ifdef BAN_INFO
+ 			MyFree(obtmp->value.ban.banstr);
+ #else
  			MyFree(obtmp->value.cp);
+ #endif
  			free_link(obtmp);
  		    }
  		if (chptr->prevch)
diff -c -r -N irc2.8.21+CSr2/ircd/s_debug.c irc2.8.21+CSr3/ircd/s_debug.c
*** irc2.8.21+CSr2/ircd/s_debug.c	Mon Jun 19 09:20:03 1995
--- irc2.8.21+CSr3/ircd/s_debug.c	Thu Jun 22 00:51:50 1995
***************
*** 135,140 ****
--- 135,143 ----
  'C',
  # endif
  #endif
+ #ifdef IDENTD_ONLY
+ 'd',
+ #endif
  #ifdef OPER_CAN_FLOOD2
  'f',
  #endif
diff -c -r -N irc2.8.21+CSr2/ircd/s_user.c irc2.8.21+CSr3/ircd/s_user.c
*** irc2.8.21+CSr2/ircd/s_user.c	Mon Jun 19 08:17:44 1995
--- irc2.8.21+CSr3/ircd/s_user.c	Mon Jun 19 23:16:27 1995
***************
*** 360,386 ****
  		aconf = sptr->confs->value.aconf;
  		if (sptr->flags & FLAGS_DOID && !(sptr->flags & FLAGS_GOTID))
  		    {
! 			/* because username may point to user->username */
                          ircstp->is_ref++;
  			sendto_one(sptr, ":%s NOTICE %s :This server will not allow connections from sites that don't run RFC1413 (pidentd). You may obtain a version for UNIX/VAX/VMX from \"ftp.eskimo.com:/security/pidentd-2.5.1.tar.gz\" via anonymous FTP.", me.name, parv[0]);
                          sendto_one(sptr, ":%s NOTICE %s : ", me.name, parv[0]);
  			sendto_one(sptr, ":%s NOTICE %s :For Windows, you have two choices. You can obtain WS_IRC+identd from 'ftp.eskimo.com:/security/Windows/wsirc14g.zip' or MIRC from 'ftp.eskimo.com:/security/Windows/mirc30b.zip'. For the Mac, try 'ftp.eskimo.com:/security/Mac/daemon100.sea.hqx'.", me.name, parv[0]);
                          sendto_one(sptr, ":%s NOTICE %s : ", me.name, parv[0]);
  			sendto_one(sptr, ":%s NOTICE %s :Users may wish to subscribe to a new mailing list 'identd-l'. This list is intended to help users install identd on their Unix, PC, Mac, and other machines.. Send email to majordomo@eskimo.com with the body of the message containing 'subscribe identd-l your@email.address'. Do NOT put anything in the subject line! It will be ignored.", me.name, parv[0]);
! 			return exit_client(cptr, sptr, &me, "Install ident");
! 
! /*
  			char	temp[USERLEN+1];
  
  			strncpyzt(temp, username, USERLEN+1);
  			*user->username = '~';
  			(void)strncpy(&user->username[1], temp, USERLEN);
  			user->username[USERLEN] = '\0';
! */			
  		    }
  		else if (sptr->flags & FLAGS_GOTID)
  			strncpyzt(user->username, sptr->username, USERLEN+1);
! 		else /* if (!(sptr->flags & FLAGS_GOTID)) */
  		{
  			char temp[USERLEN+1];
  
--- 360,385 ----
  		aconf = sptr->confs->value.aconf;
  		if (sptr->flags & FLAGS_DOID && !(sptr->flags & FLAGS_GOTID))
  		    {
! #ifdef IDENTD_ONLY
                          ircstp->is_ref++;
  			sendto_one(sptr, ":%s NOTICE %s :This server will not allow connections from sites that don't run RFC1413 (pidentd). You may obtain a version for UNIX/VAX/VMX from \"ftp.eskimo.com:/security/pidentd-2.5.1.tar.gz\" via anonymous FTP.", me.name, parv[0]);
                          sendto_one(sptr, ":%s NOTICE %s : ", me.name, parv[0]);
  			sendto_one(sptr, ":%s NOTICE %s :For Windows, you have two choices. You can obtain WS_IRC+identd from 'ftp.eskimo.com:/security/Windows/wsirc14g.zip' or MIRC from 'ftp.eskimo.com:/security/Windows/mirc30b.zip'. For the Mac, try 'ftp.eskimo.com:/security/Mac/daemon100.sea.hqx'.", me.name, parv[0]);
                          sendto_one(sptr, ":%s NOTICE %s : ", me.name, parv[0]);
  			sendto_one(sptr, ":%s NOTICE %s :Users may wish to subscribe to a new mailing list 'identd-l'. This list is intended to help users install identd on their Unix, PC, Mac, and other machines.. Send email to majordomo@eskimo.com with the body of the message containing 'subscribe identd-l your@email.address'. Do NOT put anything in the subject line! It will be ignored.", me.name, parv[0]);
! 			return exit_client(cptr, sptr, &me, "Install identd");
! #else
  			char	temp[USERLEN+1];
  
  			strncpyzt(temp, username, USERLEN+1);
  			*user->username = '~';
  			(void)strncpy(&user->username[1], temp, USERLEN);
  			user->username[USERLEN] = '\0';
! #endif
  		    }
  		else if (sptr->flags & FLAGS_GOTID)
  			strncpyzt(user->username, sptr->username, USERLEN+1);
! 		else
  		{
  			char temp[USERLEN+1];
  
***************
*** 389,398 ****
  			(void)strncpy(&user->username[1], temp, USERLEN);
  			user->username[USERLEN] = '\0';
  		}
- /*
- 		else
-                         strncpyzt(user->username, username, USERLEN+1);
- */
  		if (!BadPtr(aconf->passwd) &&
  		    !StrEq(sptr->passwd, aconf->passwd))
  		    {
--- 388,393 ----
